/*
 *  MouseCell.h
 *  GenomeMixerCPP
 */

#ifndef __GENOME_MIXER_MOUSE_CELL__
#define __GENOME_MIXER_MOUSE_CELL__

#include <iostream>
#include <stdlib.h>
#include "Mouse.h"

struct MouseCellIngredients {
    // This struct simplifies the matter of passing a lot of related data around
    Mouse* mother;
    Mouse* father;
    double litterSizeStdev;
    int    numRandomSex; // -1 indicates "use default value"
    int    numFemales; // -1 indicates "use default value"
    int    numMales;   // -1 indicates "use default value"
    bool   shouldBeExported; // whether or not this cell will be exported to the output file or not
};

class MouseCell {
    private:
        string myCollectionName;
        vector <Mouse*> maleVec;
        vector <Mouse*> femaleVec;
	
    public:
	MouseCell(void);	    // constructor
	MouseCell(string newName);  // constructor 
        //~MouseCell(void); // destructor function
	
        void   printSummary(void);
        void   addMouse(Mouse *theMouse);
        Mouse* getMouse(int id, bool sex);
        //Mouse* getFirstMouse();

        string collectionName() { return myCollectionName; } // Accessor
	int    numMice()        { return ( maleVec.size()+femaleVec.size() ); } // Accessor
	int    numMaleMice()    { return maleVec.size(); } // Accessor
	int    numFemaleMice()  { return femaleVec.size(); } // Accessor
	
	Mouse* selectRandomMale()   { return selectRandomMouse(kMALE); }
	Mouse* selectRandomFemale() { return selectRandomMouse(kFEMALE); }
        Mouse* selectRandomMouse(bool pickMouseOfThisSex);
	
};  // <-- remember the semicolon at the end of the class definition!

#endif

